#version 430 core
// tutorial: https://learnopengl.com/Advanced-Lighting/Bloom
out vec4 FragColor;
in vec2 TexCoords;

layout(binding=0) uniform sampler2D scene;
layout(binding=1) uniform sampler2D thresholdBlur;


uniform bool bloom;
uniform float exposure;

void main()
{
     vec3 hdrColor = texture(scene, TexCoords).rgb;      
    vec3 bloomColor = texture(thresholdBlur, TexCoords).rgb;
    if(bloom)
        hdrColor += bloomColor; // additive blending
    
	// tone mapping
    vec3 result = vec3(1.0) - exp(-hdrColor * exposure); 

    FragColor = vec4(hdrColor, 1.0);
	
}  