#version 430 core

 uniform sampler2D uInputTex;

  uniform int uGhosts; // number of ghost samples
   uniform float uGhostDispersal; // dispersion factor

noperspective in vec2 TexCoords;


   out vec4 fResult;

   void main() {
      vec2 texcoord = -TexCoords + vec2(1.0);
      vec2 texelSize = 1.0 / vec2(textureSize(uInputTex, 0));
 
   // ghost vector to image centre:
      vec2 ghostVec = (vec2(0.5) - texcoord) * uGhostDispersal;
   
   // sample ghosts:  
      vec4 result = vec4(0.0);
	  for (int i = 0; i < uGhosts; ++i) { 
      vec2 offset = fract(texcoord + ghostVec * float(i));
      
      float weight = length(vec2(0.5) - offset) / length(vec2(0.5));
      weight = pow(1.0 - weight, 10.0);
  
      result += texture(uInputTex, offset) * weight;
   }
   
   //TODO LensColor from 1d texture
   // result *= texture(uLensColor, length(vec2(0.5) - texcoord) / length(vec2(0.5)));
 
      fResult = result;
   }